# iosxr_netconf – Configures NetConf sub-system service on Cisco IOS-XR devices

New in version 2.5.

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module provides an abstraction that enables and configures the netconf system service running on Cisco IOS-XR Software. This module can be used to easily enable the Netconf API. Netconf provides a programmatic interface for working with configuration and state resources as defined in RFC 6242.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
netconf_port - | Default: 830 | This argument specifies the port the netconf service should listen on for SSH connections. The default port as defined in RFC 6242 is 830. aliases: listens_on
netconf_vrf - | Default: "default" | netconf vrf name aliases: vrf

provider
dictionary

Deprecated
Starting with Ansible 2.5 we recommend using `connection: network_cli`.
For more information please see the Network Guide.

A dict object containing connection details.

| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.

state
-

Choices:
- present ←
- absent

Specifies the state of the `iosxr_netconf` resource on the remote device. If the state argument is set to present the netconf service will be configured. If the state argument is set to absent the netconf service will be removed from the configuration.

## Notes

Note

- This module works with connection `network_cli`. See the IOS-XR Platform Options.
- Tested against Cisco IOS XR Software, Version 6.1.3
- For more information on using Ansible to manage network devices see the Ansible Network Guide
- For more information on using Ansible to manage Cisco devices see the Cisco integration page.

## Examples

    - name: enable netconf service on port 830
      iosxr_netconf:
        listens_on: 830
        state: present

    - name: disable netconf service
      iosxr_netconf:
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
commands string | when changed is True | Returns the command sent to the remote device Sample: ssh server netconf port 830

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Kedar Kekan (@kedarX)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.